#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleGiftLotteryMap.h"
std::auto_ptr<M_ActivityFishingCeleGiftLotteryMap> M_ActivityFishingCeleGiftLotteryMap::msSingleton(nullptr);

int M_ActivityFishingCeleGiftLotteryMap::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleGiftLotteryMapData* M_ActivityFishingCeleGiftLotteryMap::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleGiftLotteryMapData>& M_ActivityFishingCeleGiftLotteryMap::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleGiftLotteryMap::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleGiftLotteryMap.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleGiftLotteryMapData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mFreeWeight = element->IntAttribute("FreeWeight");
		data.mAdvWeight = element->IntAttribute("AdvWeight");
		data.mAdvNeedItem = element->IntAttribute("AdvNeedItem");
		data.mGiftId = element->IntAttribute("GiftId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleGiftLotteryMap Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftLotteryMap::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleGiftLotteryMap");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleGiftLotteryMap");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleGiftLotteryMapData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "FreeWeight", data.mFreeWeight);
		LuaCfgHelper::readInt(L, "AdvWeight", data.mAdvWeight);
		LuaCfgHelper::readInt(L, "AdvNeedItem", data.mAdvNeedItem);
		LuaCfgHelper::readInt(L, "GiftId", data.mGiftId);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleGiftLotteryMap Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftLotteryMap::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleGiftLotteryMap* M_ActivityFishingCeleGiftLotteryMap::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleGiftLotteryMap());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleGiftLotteryMap::Release()
{
	msSingleton.reset(nullptr);
}
